## GtkRadioButton GtkRadioButton — A choice from multiple check buttons |

## Functions

GtkWidget * | gtk_radio_button_new ()
GtkWidget * | gtk_radio_button_new_from_widget ()
GtkWidget * | gtk_radio_button_new_with_label ()
GtkWidget * | gtk_radio_button_new_with_label_from_widget ()
GtkWidget * | gtk_radio_button_new_with_mnemonic ()
GtkWidget * | gtk_radio_button_new_with_mnemonic_from_widget ()
void | gtk_radio_button_set_group ()
GSList * | gtk_radio_button_get_group ()

## Properties

GtkRadioButton * | group | Write

## Signals

void | group-changed | Run First

## Types and Values

struct | GtkRadioButton
#define | gtk_radio_button_group

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkObject
                ╰── GtkWidget
                    ╰── GtkContainer
                        ╰── GtkBin
                            ╰── GtkButton
                                ╰── GtkToggleButton
                                    ╰── GtkCheckButton
                                        ╰── GtkRadioButton

## Implemented Interfaces

GtkRadioButton implements AtkImplementorIface, GtkBuildable and GtkActivatable.

## Includes

    #include <gtk/gtk.h>

## Description

A single radio button performs the same basic function as a GtkCheckButton, as its position in the object hierarchy reflects. It is only when multiple radio buttons are grouped together that they become a different user interface component in their own right.

Every radio button is a member of some group of radio buttons. When one is selected, all other radio buttons in the same group are deselected. A GtkRadioButton is one way of giving the user a choice from many options.

Radio button widgets are created with `gtk_radio_button_new()`, passing NULL as the argument if this is the first radio button in a group. In subsequent calls, the group you wish to add this button to should be passed as an argument. Optionally, `gtk_radio_button_new_with_label()` can be used if you want a text label on the radio button.

Alternatively, when adding widgets to an existing group of radio buttons, use `gtk_radio_button_new_from_widget()` with a GtkRadioButton that already has a group assigned to it. The convenience function `gtk_radio_button_new_with_label_from_widget()` is also provided.

To retrieve the group a GtkRadioButton is assigned to, use `gtk_radio_button_get_group()`.

To remove a GtkRadioButton from one group and make it part of a new one, use `gtk_radio_button_set_group()`.

The group list does not need to be freed, as each GtkRadioButton will remove itself and its list item when it is destroyed.

Example 10. How to create a group of two radio buttons.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    void create_radio_buttons (void) {
       GtkWidget *window, *radio1, *radio2, *box, *entry;
       window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
       box = gtk_vbox_new (TRUE, 2);
       /* Create a radio button with a GtkEntry widget */
       radio1 = gtk_radio_button_new (NULL);
       entry = gtk_entry_new ();
       gtk_container_add (GTK_CONTAINER (radio1), entry);
       /* Create a radio button with a label */
       radio2 = gtk_radio_button_new_with_label_from_widget (GTK_RADIO_BUTTON (radio1),
                                "I'm the second radio button.");
       /* Pack them into a box, then show all the widgets */
       gtk_box_pack_start (GTK_BOX (box), radio1, TRUE, TRUE, 2);
       gtk_box_pack_start (GTK_BOX (box), radio2, TRUE, TRUE, 2);
       gtk_container_add (GTK_CONTAINER (window), box);
       gtk_widget_show_all (window);
       return;
    }

When an unselected button in the group is clicked the clicked button receives the "toggled" signal, as does the previously selected button. Inside the "toggled" handler, `gtk_toggle_button_get_active()` can be used to determine if the button has been selected or deselected.

## Functions

### gtk_radio_button_new ()

    GtkWidget *
    gtk_radio_button_new (GSList *group);

Creates a new GtkRadioButton. To be of any practical value, a widget should then be packed into the radio button.

Creates a new GtkRadioButton. To be of any practical value, a widget should then be packed into the radio button.

#### Parameters

group | an existing radio button group, or `NULL` if you are creating a new group. | [allow-none]

#### Returns

a new radio button

### gtk_radio_button_new_from_widget ()

    GtkWidget *
    gtk_radio_button_new_from_widget (GtkRadioButton *radio_group_member);

Creates a new GtkRadioButton, adding it to the same group as `radio_group_member` . As with `gtk_radio_button_new()`, a widget should be packed into the radio button.

Creates a new GtkRadioButton, adding it to the same group as `radio_group_member` . As with `gtk_radio_button_new()`, a widget should be packed into the radio button.

#### Parameters

radio_group_member | an existing GtkRadioButton. | [allow-none]

#### Returns

a new radio button.

[transfer none]

### gtk_radio_button_new_with_label ()

    GtkWidget *
    gtk_radio_button_new_with_label (GSList *group,
                                     const gchar *label);

Creates a new GtkRadioButton with a text label.

Creates a new GtkRadioButton with a text label.

#### Parameters

group | an existing radio button group, or `NULL` if you are creating a new group. | [allow-none]
label | the text label to display next to the radio button. |

#### Returns

a new radio button.

### gtk_radio_button_new_with_label_from_widget ()

    GtkWidget *
    gtk_radio_button_new_with_label_from_widget
                                   (GtkRadioButton *radio_group_member,
                                    const gchar *label);

Creates a new GtkRadioButton with a text label, adding it to the same group as `radio_group_member` .

Creates a new GtkRadioButton with a text label, adding it to the same group as `radio_group_member` .

[constructor]

#### Parameters

radio_group_member | widget to get radio group from or `NULL`. | [allow-none]
label | a text string to display next to the radio button. |

#### Returns

a new radio button.

[transfer none]

### gtk_radio_button_new_with_mnemonic ()

    GtkWidget *
    gtk_radio_button_new_with_mnemonic (GSList *group,
                                        const gchar *label);

Creates a new GtkRadioButton containing a label, adding it to the same group as `group` . The label will be created using `gtk_label_new_with_mnemonic()`, so underscores in `label` indicate the mnemonic for the button.

#### Parameters

group | the radio button group |
label | the text of the button, with an underscore in front of the mnemonic character |

#### Returns

a new GtkRadioButton

### gtk_radio_button_new_with_mnemonic_from_widget ()

    GtkWidget *
    gtk_radio_button_new_with_mnemonic_from_widget
                                   (GtkRadioButton *radio_group_member,
                                    const gchar *label);

Creates a new GtkRadioButton containing a label. The label will be created using `gtk_label_new_with_mnemonic()`, so underscores in `label` indicate the mnemonic for the button.

[constructor]

#### Parameters

radio_group_member | widget to get radio group from or `NULL`. | [allow-none]
label | the text of the button, with an underscore in front of the mnemonic character |

#### Returns

a new GtkRadioButton.

[transfer none]

### gtk_radio_button_set_group ()

    void
    gtk_radio_button_set_group (GtkRadioButton *radio_button,
                                GSList *group);

Sets a GtkRadioButton's group. It should be noted that this does not change the layout of your interface in any way, so if you are changing the group, it is likely you will need to re-arrange the user interface to reflect these changes.

Sets a GtkRadioButton's group. It should be noted that this does not change the layout of your interface in any way, so if you are changing the group, it is likely you will need to re-arrange the user interface to reflect these changes.

#### Parameters

radio_button | a GtkRadioButton. |
group | an existing radio button group, such as one returned from `gtk_radio_button_get_group()`. | [transfer none][element-type GtkRadioButton]

### gtk_radio_button_get_group ()

    GSList *
    gtk_radio_button_get_group (GtkRadioButton *radio_button);

Retrieves the group assigned to a radio button.

#### Parameters

radio_button | a GtkRadioButton. |

#### Returns

a linked list containing all the radio buttons in the same group as `radio_button` . The returned list is owned by the radio button and must not be modified or freed.

[element-type GtkRadioButton][transfer none]

## Types and Values

### struct GtkRadioButton

    struct GtkRadioButton;

Contains only private data that should be read and manipulated using the functions below.

### gtk_radio_button_group

    #define gtk_radio_button_group gtk_radio_button_get_group

`gtk_radio_button_group` is deprecated and should not be used in newly-written code.

Deprecated compatibility macro. Use `gtk_radio_button_get_group()` instead.

## Property Details

### The `“group”` property

      “group”                    GtkRadioButton *

Sets a new group for a radio button.

Flags: Write

## Signal Details

### The `“group-changed”` signal

    void
    user_function (GtkRadioButton *style,
                   gpointer        user_data)

Emitted when the group of radio buttons that a radio button belongs to changes. This is emitted when a radio button switches from being alone to being part of a group of 2 or more buttons, or vice-versa, and when a button is moved from one group of 2 or more buttons to a different one, but not when the composition of the group that a button belongs to changes.

#### Parameters

style | the object which received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Run First

Since: 2.4

## See Also

GtkOptionMenu | Another way of offering the user a single choice from many.